<template>
  <div class="chart-wrapper">
    <span>Tahun : </span>
    <select v-model="selectedYear" @change="filterYear($event)">
      <option v-for="option in options" :value="option.text" :key="option.value">
        {{ option.text }}
      </option>
    </select>
    <GChart
      v-loading="loading"
      type="ColumnChart"
      :data="newData"
      :options="chartOptions"
      :resizeDebounce="500"
      :key="rerender"
      :events="chartEvents"
    />
  </div>
</template>
<script>
import { GChart } from 'vue-google-charts';
import axios from "axios"

export default {
  name: 'UserChart',
  components: {
    GChart
  },
  data() {
    return {
      chartData: null,
      loading: true,
      chartOptions: {
        chart: {
          title: 'User Aktif Per Periode'
        },
        legend: { position: 'top', maxLines: 3 },
        bar: { groupWidth: '80%' },
        isStacked: true,
        height: 400,
        series: {
          0: { color: "#F50300" },
          1: { color: "#FFBA00" },
          2: { color: "#D4501A" },
          3: { color: "#FE00D4" },
          4: { color: "#00CA1E" },
          5: { color: "#0241FE" }
        }
      },
      rerender: 0,
      farmer_period: [],
      newData: [],
      chartEvents: {
        click: (e) => {
          let idx = e.targetID.match(/\d+/g);
          if (idx && idx.length < 3) {
            idx = Number(idx[0])
            this.isFiltered ? this.allData() : this.filterChart(idx);
          }
        }
      },
      isFiltered: false,
      params: '',
      defaultColors: {
        0: { color: "#F50300" },
        1: { color: "#FFBA00" },
        2: { color: "#D4501A" },
        3: { color: "#FE00D4" },
        4: { color: "#00CA1E" },
        5: { color: "#0241FE" }
      },
      selectedYear: '2021',
      options: [
        { text: '2021', value: '1' },
        { text: '2020', value: '2' },
        { text: '2019', value: '3' }
      ]
    }
  },
  methods: {
    getData() {
      this.loading = true
      this.getUserPeriod(this.params)
    },
    async getUserPeriod(param) {
      try {
        const url = `http://ritx.herokuapp.com/old/dashboard/?year=`
        const response = await axios.get(url + param)
        this.farmer_period = response.data
        this.getChartData(this.farmer_period)
        this.allData()
      } catch (err) {
        if (err.response) {
          console.log("Server Error:", err)
        } else if (err.request) {
          console.log("Network Error:", err)
        } else {
          console.log("Client Error:", err)
        }
      }
    },
    getChartData(dataResponse) {
      if (dataResponse) {
        const dataChart = [];
        Object.keys(dataResponse).forEach((e, index) => {
          dataResponse[e] = dataResponse[e].filter(item => item.status !== "Non Aktif");
          if (index === 0) {
            const b = dataResponse[e].map(r => r.status)
            b.unshift("Month")
            dataChart.push(b)
            dataChart[0][6] = 'Petani Mencatat Aktifitas'
          }
          const a1 = [e]
          dataResponse[e].forEach(c => {
            a1.push(c.farmer_count)
            c.status
          })
          a1[0] = new Date(a1[0].split('-')[1], a1[0].split('-')[0] - 1, 1).toLocaleString('default', { month: 'long' });
          dataChart.push(a1)
        })
        this.chartData = dataChart
        setTimeout(() => {
          this.loading = false;
          this.params = ''
        }, 1.5 * 1000)
      } else {
        this.loading = false
      }
    },
    filterChart(idx) {
      this.allData()
      for (let i = 0; i < this.newData.length; i++) {
        this.newData[i] = [this.newData[i][0], this.newData[i][idx + 1]]
      }
      this.chartOptions.series[0].color = this.defaultColors[idx].color;
      this.isFiltered = true
    },
    allData() {
      this.newData = [...this.chartData];
      this.chartOptions.series[0].color = this.defaultColors[0].color;
      this.isFiltered = false;
    },
    filterYear(event) {
      this.params = event.target.value
      this.getData()
    }
  },
  created() {
    this.getData();
  }
}
</script>
